/*   
    12:   
          09-01-06
    2: 
   
   :
      1  2    (x1,y1)  (x2,y2) 
          a1=2->1->P  a2=1->2->P 
         (Px, Py)
   
   :   a1  a2      (grad)
*/

#include <iostream>
#include <cmath>
using namespace std;

int main()
{
    double const pi=4.*atan(1.);
    double x1,x2,y1,y2,a1g,a2g;                 //  
    double dx,dy,a1,a2,a3,d12,d1P,len12,len1P;
    double Px,Py;                               //  
    
//  
    cout<<"\nEnter coordinates of point 1: ";
    cout<<"\n\tx1 = ";
    cin>>x1;
    cout<<"\ty1 = ";
    cin>>y1;
    cout<<"\nEnter coordinates of point 2: ";
    cout<<"\n\tx2 = ";
    cin>>x2;
    cout<<"\ty2 = ";
    cin>>y2;
    cout<<"\nEnter angle 2->1->P (in grad): a1 = ";
    cin>>a1g;
    cout<<"\nEnter angle 1->2->P (in grad): a2 = ";
    cin>>a2g;
    
    a1=a1g*pi/200.;                         //    
    a2=a2g*pi/200.;
    dx=x2-x1;
    dy=y2-y1;

//      1->2    
    if (dx==0.) 
         if (dy>0.) d12=pi/2.;
         else if (dy<0.) d12=pi*3./2.;
         else {
              cout<<"\n Points 1 and 2 coincide ! - NO solution";
              return 1;
              }
    else d12=atan(dy/dx);

//      
    len12=sqrt(pow(dx,2)+pow(dy,2));            //   1->2
    a3=pi-a1-a2;                                //    
    len1P=len12*sin(a2)/sin(a3);                //   1->
    d1P=d12+a1;                                 //    1->
    Px=x1+len1P*cos(d1P);                       //   
    Py=y1+len1P*sin(d1P);

//          
    cout<<"\n\t Coordinates of P";
    cout<<"\n\tPx = "<<Px;
    cout<<"\n\tPy = "<<Py<<endl;
    cout<<endl;
    
    system("pause");
    return 0;
}
