/*   
    12:   
          09-01-06
    3:  
      
   :
       (x(i),y(i)), i=1,2,...,N    (i)
    .    .
   
    1:         
           .
    2:      ,  , 50
    3:        
   
*/

#include <iostream>
#include <cmath>
using namespace std;

//  
double x[51],y[51];          //   
int N;                       //     

void Vertex_coords()         //    
{
    cout<<"\nEnter coordinates of polygon vertices: ";
    for (int i=1;i<=N;i++) {
        cout<<"\n x("<<i<<") = ";
        cin>>x[i];
        cout<<" y("<<i<<") = ";
        cin>>y[i]; }
    x[0]=x[N];               //    ""    
    y[0]=y[N];
}

double triangle_area(double a, double b, double c)         //  
{
       double s,E;
       s=0.5*(a+b+c);
       E=sqrt(s*(s-a)*(s-b)*(s-c));      //   
       return E;
}

double side_length(double x1, double y1, double x2, double y2)        //  
{
       double len;
       len=sqrt(pow((x1-x2),2)+pow((y1-y2),2));
       return len;
}

double mean_val(double a[], int n)              //    
{
       double s=0.;
       for (int i=1;i<=n;i++) 
           s=s+a[i];
       s=s/n;
       return s;
}

int main()
{
    do {
        cout<<"\nEnter number N of polygon sides (N<=50): ";
        cin>>N; }
    while ((N>50) || (N<2));
    
    double side[N+1],central[N+1];               //   "" 
    double xk,yk,area;                           //    
    int i;

    Vertex_coords();                             //  
    
    xk=mean_val(x,N);                            //  
    yk=mean_val(y,N);    
    
    for (i=1;i<=N;i++) {
        side[i]=side_length(x[i-1],y[i-1],x[i],y[i]);       //  
        central[i]=side_length(xk,yk,x[i],y[i]);            //  
        }
    central[0]=central[N];                       // 
    area=0.;
    for (i=1;i<=N;i++)                           //   
        area=area+triangle_area(central[i-1],side[i],central[i]);        
        
    cout<<"\n Area of Polygon = "<<area<<endl;
    cout<<endl;
    
    system("pause");
    return 0;
}
